<template lang="pug">
q-field.collection-recipe(
	v-model="model"
	:label="label"
	dense
	outlined
	hide-bottom-space
	:required="undefined"
	:rules="getRules"
	stack-label
	:lazy-rules="true"
	ref="fieldRef"
)
	template(#control)
		.q-gutter-md.q-py-md.collection-recipe__list
			.recipes-step(v-for="(item, index) in model", :key="item.id" flat bordered)

				.flex.full-width.vertical-middle.q-mb-md
					.text-h5 Шаг {{ item.step + 1 }}
					q-space
					q-btn(
						v-if="index > 0"
						size="12px"
						flat
						dense
						round
						color="primary"
						icon="arrow_upward"
						@click="moveItemUp(index)"
					)
						ui-tooltip Поднять шаг вверх
					q-btn(
						v-if="index < model.length - 1"
						size="12px"
						flat
						dense
						round
						color="primary"
						icon="arrow_downward"
						@click="moveItemDown(index)"
					)
						ui-tooltip Опустить шаг вниз
					q-btn(
						size="12px"
						flat
						dense
						round
						color="negative"
						icon="close"
						@click="removeItem(index)"
					)
						ui-tooltip Удалить шаг {{ item.step + 1 }}

				.recipes-step__info
					.q-gutter-md

						ui-input-text(
							v-model="item.title",
							label="Заголовок",
							required,
						)

						ui-input-text.recipes-step__instruction(
							v-model="item.instruction",
							label="Описание",
							type="textarea"
							autogrow
							required,
						)

				.recipes-step__image
					ui-uploader-image(
						v-model="item.visual",
						label="Изображение",
						:rules="[ val => val && val.length > 0 || 'Необходимо добавить изображение шага рецепта']"
					)

				q-separator.full-width.q-mt-md

			.row.items-start
				q-btn.self-center(
					v-if="!isMaxCount"
					size="50px"
					flat
					color="blue-grey-4"
					round
					icon="playlist_add"
					@click="addItem"
				)

</template>

<script lang="ts">
	import { computed, defineComponent, reactive, ref } from 'vue'
	import { IRecipeStep, IVisual } from '@/plugins/utils/types'
	import UiUploaderImage from '@/components/ui/UiUploaderImage.vue'
	import UiInputText from '@/components/ui/UiInputText.vue'
	import UiTooltip from '@/components/ui/UiTooltip.vue'

	export default defineComponent({
		name: 'CollectionRecipe',

		components: {
			UiUploaderImage,
			UiInputText,
			UiTooltip,
		},

		props: {
			modelValue: {
				type: [Object, Array],
				default: () => [],
			},
			max: {
				type: Number,
				default: Infinity,
			},
			label: {
				type: String,
				default: 'Рецепты',
			},
			required: {
				type: Boolean,
				default: false,
			},
			rules: {
				type: Array,
				default: () => [],
			},
		},

		emits: ['update:modelValue'],

		setup(props, { emit }) {
			const fieldRef = ref(null)

			const model = computed({
				get: (): IRecipeStep[] => {
					return props.modelValue
				},
				set: (val) => {
					emit('update:modelValue', val)
				},
			})

			const isMaxCount = computed(() => model.value.length >= props.max)

			const getRules = computed(() => {
				const hasValue = props.required ? [(val: IRecipeStep[]) => val.length > 0 || ''] : []

				return [...hasValue, ...props.rules]
			})

			const moveItem = (index: number, to: number) => {
				const array = model.value

				const newIndex = index + to
				if (newIndex < 0 || newIndex == array.length) return
				const indexes = [index, newIndex].sort()
				array.splice(indexes[0], 2, array[indexes[1]], array[indexes[0]])
				model.value = array.map((item, idx) => {
					const { step, ...all } = item
					return {
						step: idx,
						...all,
					}
				})
			}

			return {
				model,
				getRules,
				fieldRef,

				isMaxCount,

				removeItem(idx: number) {
					model.value = [...model.value.slice(0, idx), ...model.value.slice(idx + 1)].map((item, idx) => {
						const { step, ...all } = item
						return {
							step: idx,
							...all,
						}
					})
				},

				moveItemUp(idx: number) {
					moveItem(idx, -1)
				},

				moveItemDown(idx: number) {
					moveItem(idx, 1)
				},
				async addItem() {
					await model.value.push({
						step: model.value.length,
						title: '',
						instruction: '',
						visual: undefined,
					})
					const fieldAction = fieldRef.value as any
					fieldAction.resetValidation()
				},
			}
		},
	})
</script>

<style lang="scss" scoped>
	.recipes-step {
		display: flex;
		flex-wrap: wrap;

		&__info {
			flex: 1 1 0;
		}

		&__image {
			width: 100%;
			margin-top: 16px;

			@include breakPoint($breakpoint-sm) {
				width: 220px;
				margin-top: 0;
				margin-left: 16px;
			}
		}

		&__instruction {
			&:deep(.q-field__control-container) {
				min-height: 117px;
			}
		}
	}

	.collection-recipe {
		&__list {
			display: block;
			width: 100%;
		}

		&:deep(.q-field__control-container) {
			padding-top: 0 !important;
		}

		&:deep(.q-field__label) {
			transform: translateY(-85%) scale(0.75) !important;
			z-index: 1;
			background: $main-background;
			padding: 0 5px;
			margin-left: -5px;
			right: auto;
			max-width: calc(135% + 10px);
		}
	}
</style>
